import java.util.concurrent.Semaphore;

class PrecGraph
{
  public static void main (String [] args)
    throws InterruptedException
  {
    Semaphore s1 = new Semaphore (2);
    Semaphore s2 = new Semaphore (1);
    Semaphore s3 = new Semaphore (2);

    Thread t1 = new Thread (new T1(s1));

    Thread t2 = new Thread (new TOther(2,s1,s2));
    Thread t3 = new Thread (new TOther(3,s1,s3));
    Thread t4 = new Thread (new TOther(4,s2,s3));

    Thread t5 = new Thread (new T5(s3));

    t1.start();
    t2.start();
    t4.start();
    t5.start();
    t3.start();

    t5.join ();
  }

  private static class T1 implements Runnable
  {
    private Semaphore _out;

    public T1 (Semaphore out)
      throws InterruptedException
    {
      _out = out;
      _out.acquire (2);
    }

    public void run ()
    {
      System.out.println ("Doing T1 work");
      _out.release (2);
    }
  }
  
  private static class TOther implements Runnable
  {
    private Semaphore _out;
    private Semaphore _in ;
    private int _id;
      
    public TOther (int id, Semaphore in, Semaphore out)
      throws InterruptedException
    {
      _id = id;
      _in = in;
      _out = out;
      _out.acquire (1);
    }

    public void run ()
    {
      try
        {
          _in.acquire (1);
        }
      catch (InterruptedException ie)
        {
          throw new RuntimeException(ie.toString());
        }
      System.out.println ("Doing T" + _id + " work");
      _out.release (1);
    }
  }

  private static class T5 implements Runnable
  {
    private Semaphore _in ;
      
    public T5 (Semaphore in)
    {
      _in = in;
    }

    public void run ()
    {
      try 
        {
          _in.acquire (2);
        }
      catch (InterruptedException ie)
        {
          throw new RuntimeException(ie.toString());
        }
      System.out.println ("Doing T5 work");
    }
  }
}